# coding: utf-8

"""
    KFM - Application API

    KFM manages and stores key fragments. The core operations of each KFM instance are as follows: Creating secure random encryption keys which will be used as a master key fragment. Managing data storage for key fragments. Performing a key fragment derivation function, which generates a derived fragment from the original key fragment.  # noqa: E501

    OpenAPI spec version: 1.0.5
    Contact: refael@akeyless-security.com
    Generated by: https://github.com/swagger-api/swagger-codegen.git
"""


import pprint
import re  # noqa: F401

import six


class CreateAccountReplyObj(object):
    """NOTE: This class is auto generated by the swagger code generator program.

    Do not edit the class manually.
    """

    """
    Attributes:
      swagger_types (dict): The key is attribute name
                            and the value is attribute type.
      attribute_map (dict): The key is attribute name
                            and the value is json key in definition.
    """
    swagger_types = {
        'account_id': 'str',
        'admin_user_policy_id': 'str'
    }

    attribute_map = {
        'account_id': 'account_id',
        'admin_user_policy_id': 'admin_user_policy_id'
    }

    def __init__(self, account_id=None, admin_user_policy_id=None):  # noqa: E501
        """CreateAccountReplyObj - a model defined in Swagger"""  # noqa: E501

        self._account_id = None
        self._admin_user_policy_id = None
        self.discriminator = None

        if account_id is not None:
            self.account_id = account_id
        if admin_user_policy_id is not None:
            self.admin_user_policy_id = admin_user_policy_id

    @property
    def account_id(self):
        """Gets the account_id of this CreateAccountReplyObj.  # noqa: E501


        :return: The account_id of this CreateAccountReplyObj.  # noqa: E501
        :rtype: str
        """
        return self._account_id

    @account_id.setter
    def account_id(self, account_id):
        """Sets the account_id of this CreateAccountReplyObj.


        :param account_id: The account_id of this CreateAccountReplyObj.  # noqa: E501
        :type: str
        """

        self._account_id = account_id

    @property
    def admin_user_policy_id(self):
        """Gets the admin_user_policy_id of this CreateAccountReplyObj.  # noqa: E501


        :return: The admin_user_policy_id of this CreateAccountReplyObj.  # noqa: E501
        :rtype: str
        """
        return self._admin_user_policy_id

    @admin_user_policy_id.setter
    def admin_user_policy_id(self, admin_user_policy_id):
        """Sets the admin_user_policy_id of this CreateAccountReplyObj.


        :param admin_user_policy_id: The admin_user_policy_id of this CreateAccountReplyObj.  # noqa: E501
        :type: str
        """

        self._admin_user_policy_id = admin_user_policy_id

    def to_dict(self):
        """Returns the model properties as a dict"""
        result = {}

        for attr, _ in six.iteritems(self.swagger_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1].to_dict())
                    if hasattr(item[1], "to_dict") else item,
                    value.items()
                ))
            else:
                result[attr] = value

        return result

    def to_str(self):
        """Returns the string representation of the model"""
        return pprint.pformat(self.to_dict())

    def __repr__(self):
        """For `print` and `pprint`"""
        return self.to_str()

    def __eq__(self, other):
        """Returns true if both objects are equal"""
        if not isinstance(other, CreateAccountReplyObj):
            return False

        return self.__dict__ == other.__dict__

    def __ne__(self, other):
        """Returns true if both objects are not equal"""
        return not self == other
