# coding: utf-8

"""
    KFM - Application API

    KFM manages and stores key fragments. The core operations of each KFM instance are as follows: Creating secure random encryption keys which will be used as a master key fragment. Managing data storage for key fragments. Performing a key fragment derivation function, which generates a derived fragment from the original key fragment.  # noqa: E501

    OpenAPI spec version: 1.0.5
    Contact: refael@akeyless-security.com
    Generated by: https://github.com/swagger-api/swagger-codegen.git
"""


import pprint
import re  # noqa: F401

import six


class SecretAccessCredsReplyObj(object):
    """NOTE: This class is auto generated by the swagger code generator program.

    Do not edit the class manually.
    """

    """
    Attributes:
      swagger_types (dict): The key is attribute name
                            and the value is attribute type.
      attribute_map (dict): The key is attribute name
                            and the value is json key in definition.
    """
    swagger_types = {
        'kf_ms_hosts_dns_map': 'dict(str, str)',
        'credential': 'str',
        'expiry': 'int',
        'item_id': 'int',
        'item_name': 'str',
        'item_type': 'str',
        'item_version': 'int',
        'protected_key_type': 'str',
        'restricted_dd': 'str',
        'secret_enc_val': 'str'
    }

    attribute_map = {
        'kf_ms_hosts_dns_map': 'KFMsHostsDNSMap',
        'credential': 'credential',
        'expiry': 'expiry',
        'item_id': 'item_id',
        'item_name': 'item_name',
        'item_type': 'item_type',
        'item_version': 'item_version',
        'protected_key_type': 'protected_key_type',
        'restricted_dd': 'restricted_dd',
        'secret_enc_val': 'secret_enc_val'
    }

    def __init__(self, kf_ms_hosts_dns_map=None, credential=None, expiry=None, item_id=None, item_name=None, item_type=None, item_version=None, protected_key_type=None, restricted_dd=None, secret_enc_val=None):  # noqa: E501
        """SecretAccessCredsReplyObj - a model defined in Swagger"""  # noqa: E501

        self._kf_ms_hosts_dns_map = None
        self._credential = None
        self._expiry = None
        self._item_id = None
        self._item_name = None
        self._item_type = None
        self._item_version = None
        self._protected_key_type = None
        self._restricted_dd = None
        self._secret_enc_val = None
        self.discriminator = None

        if kf_ms_hosts_dns_map is not None:
            self.kf_ms_hosts_dns_map = kf_ms_hosts_dns_map
        if credential is not None:
            self.credential = credential
        if expiry is not None:
            self.expiry = expiry
        if item_id is not None:
            self.item_id = item_id
        if item_name is not None:
            self.item_name = item_name
        if item_type is not None:
            self.item_type = item_type
        if item_version is not None:
            self.item_version = item_version
        if protected_key_type is not None:
            self.protected_key_type = protected_key_type
        if restricted_dd is not None:
            self.restricted_dd = restricted_dd
        if secret_enc_val is not None:
            self.secret_enc_val = secret_enc_val

    @property
    def kf_ms_hosts_dns_map(self):
        """Gets the kf_ms_hosts_dns_map of this SecretAccessCredsReplyObj.  # noqa: E501

        Mapping between the serial number of the key protected fragments and the KFMs hosts DNS in which they are stored  # noqa: E501

        :return: The kf_ms_hosts_dns_map of this SecretAccessCredsReplyObj.  # noqa: E501
        :rtype: dict(str, str)
        """
        return self._kf_ms_hosts_dns_map

    @kf_ms_hosts_dns_map.setter
    def kf_ms_hosts_dns_map(self, kf_ms_hosts_dns_map):
        """Sets the kf_ms_hosts_dns_map of this SecretAccessCredsReplyObj.

        Mapping between the serial number of the key protected fragments and the KFMs hosts DNS in which they are stored  # noqa: E501

        :param kf_ms_hosts_dns_map: The kf_ms_hosts_dns_map of this SecretAccessCredsReplyObj.  # noqa: E501
        :type: dict(str, str)
        """

        self._kf_ms_hosts_dns_map = kf_ms_hosts_dns_map

    @property
    def credential(self):
        """Gets the credential of this SecretAccessCredsReplyObj.  # noqa: E501

        Temporary credentials string (JWT format)  # noqa: E501

        :return: The credential of this SecretAccessCredsReplyObj.  # noqa: E501
        :rtype: str
        """
        return self._credential

    @credential.setter
    def credential(self, credential):
        """Sets the credential of this SecretAccessCredsReplyObj.

        Temporary credentials string (JWT format)  # noqa: E501

        :param credential: The credential of this SecretAccessCredsReplyObj.  # noqa: E501
        :type: str
        """

        self._credential = credential

    @property
    def expiry(self):
        """Gets the expiry of this SecretAccessCredsReplyObj.  # noqa: E501

        Credentials expiration date  # noqa: E501

        :return: The expiry of this SecretAccessCredsReplyObj.  # noqa: E501
        :rtype: int
        """
        return self._expiry

    @expiry.setter
    def expiry(self, expiry):
        """Sets the expiry of this SecretAccessCredsReplyObj.

        Credentials expiration date  # noqa: E501

        :param expiry: The expiry of this SecretAccessCredsReplyObj.  # noqa: E501
        :type: int
        """

        self._expiry = expiry

    @property
    def item_id(self):
        """Gets the item_id of this SecretAccessCredsReplyObj.  # noqa: E501


        :return: The item_id of this SecretAccessCredsReplyObj.  # noqa: E501
        :rtype: int
        """
        return self._item_id

    @item_id.setter
    def item_id(self, item_id):
        """Sets the item_id of this SecretAccessCredsReplyObj.


        :param item_id: The item_id of this SecretAccessCredsReplyObj.  # noqa: E501
        :type: int
        """

        self._item_id = item_id

    @property
    def item_name(self):
        """Gets the item_name of this SecretAccessCredsReplyObj.  # noqa: E501

        The name, id, version and type of the secret item  # noqa: E501

        :return: The item_name of this SecretAccessCredsReplyObj.  # noqa: E501
        :rtype: str
        """
        return self._item_name

    @item_name.setter
    def item_name(self, item_name):
        """Sets the item_name of this SecretAccessCredsReplyObj.

        The name, id, version and type of the secret item  # noqa: E501

        :param item_name: The item_name of this SecretAccessCredsReplyObj.  # noqa: E501
        :type: str
        """

        self._item_name = item_name

    @property
    def item_type(self):
        """Gets the item_type of this SecretAccessCredsReplyObj.  # noqa: E501


        :return: The item_type of this SecretAccessCredsReplyObj.  # noqa: E501
        :rtype: str
        """
        return self._item_type

    @item_type.setter
    def item_type(self, item_type):
        """Sets the item_type of this SecretAccessCredsReplyObj.


        :param item_type: The item_type of this SecretAccessCredsReplyObj.  # noqa: E501
        :type: str
        """

        self._item_type = item_type

    @property
    def item_version(self):
        """Gets the item_version of this SecretAccessCredsReplyObj.  # noqa: E501


        :return: The item_version of this SecretAccessCredsReplyObj.  # noqa: E501
        :rtype: int
        """
        return self._item_version

    @item_version.setter
    def item_version(self, item_version):
        """Sets the item_version of this SecretAccessCredsReplyObj.


        :param item_version: The item_version of this SecretAccessCredsReplyObj.  # noqa: E501
        :type: int
        """

        self._item_version = item_version

    @property
    def protected_key_type(self):
        """Gets the protected_key_type of this SecretAccessCredsReplyObj.  # noqa: E501

        The protected key type  # noqa: E501

        :return: The protected_key_type of this SecretAccessCredsReplyObj.  # noqa: E501
        :rtype: str
        """
        return self._protected_key_type

    @protected_key_type.setter
    def protected_key_type(self, protected_key_type):
        """Sets the protected_key_type of this SecretAccessCredsReplyObj.

        The protected key type  # noqa: E501

        :param protected_key_type: The protected_key_type of this SecretAccessCredsReplyObj.  # noqa: E501
        :type: str
        """

        self._protected_key_type = protected_key_type

    @property
    def restricted_dd(self):
        """Gets the restricted_dd of this SecretAccessCredsReplyObj.  # noqa: E501

        Restricted derivation data for the protected key derive operation  # noqa: E501

        :return: The restricted_dd of this SecretAccessCredsReplyObj.  # noqa: E501
        :rtype: str
        """
        return self._restricted_dd

    @restricted_dd.setter
    def restricted_dd(self, restricted_dd):
        """Sets the restricted_dd of this SecretAccessCredsReplyObj.

        Restricted derivation data for the protected key derive operation  # noqa: E501

        :param restricted_dd: The restricted_dd of this SecretAccessCredsReplyObj.  # noqa: E501
        :type: str
        """

        self._restricted_dd = restricted_dd

    @property
    def secret_enc_val(self):
        """Gets the secret_enc_val of this SecretAccessCredsReplyObj.  # noqa: E501

        The encrypted secret value.  # noqa: E501

        :return: The secret_enc_val of this SecretAccessCredsReplyObj.  # noqa: E501
        :rtype: str
        """
        return self._secret_enc_val

    @secret_enc_val.setter
    def secret_enc_val(self, secret_enc_val):
        """Sets the secret_enc_val of this SecretAccessCredsReplyObj.

        The encrypted secret value.  # noqa: E501

        :param secret_enc_val: The secret_enc_val of this SecretAccessCredsReplyObj.  # noqa: E501
        :type: str
        """

        self._secret_enc_val = secret_enc_val

    def to_dict(self):
        """Returns the model properties as a dict"""
        result = {}

        for attr, _ in six.iteritems(self.swagger_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1].to_dict())
                    if hasattr(item[1], "to_dict") else item,
                    value.items()
                ))
            else:
                result[attr] = value

        return result

    def to_str(self):
        """Returns the string representation of the model"""
        return pprint.pformat(self.to_dict())

    def __repr__(self):
        """For `print` and `pprint`"""
        return self.to_str()

    def __eq__(self, other):
        """Returns true if both objects are equal"""
        if not isinstance(other, SecretAccessCredsReplyObj):
            return False

        return self.__dict__ == other.__dict__

    def __ne__(self, other):
        """Returns true if both objects are not equal"""
        return not self == other
